<div class="point reachable" style="-webkit-transform: translate(2200px, -100px); width: 1500px; height: 400px"><span>●</span> Queues</div>

<div class="container" style="-webkit-transform: translate(2400px, 250px);">
  
<div class="slide reachable" id="queues" markdown="1">

# Queues

* A queue is a set of items stored for later processing.  
 In the context of Drupal, it is a system implementing <code>DrupalQueueInterface</code>.
* Queues are not _reliable_ by default: items can be lost or delivered twice, the order is not preserved. Queues that are actually reliable can implement <code>DrupalReliableQueueInterface</code>.

</div>

<div class="slide reachable" style="left: 500px" id="queues-semantics" markdown="1">

# Simple semantics

Job creation:

<?php
$queue = DrupalQueue::get('my_queue');
$queue->createItem(array(
  // Arbitrary data.
  'url' => 'http://drupal.org/rss.xml',
));
?>

Worker:

<?php
$queue = DrupalQueue::get('my_queue');
if ($item = $queue->claimItem()) {
  // Do the processing.
  // [...]
  $queue->deleteItem($item);
}
?>

</div>

<div class="slide reachable" style="left: 1000px" id="queues-workers" markdown="1">

# Working queues

* With <code>hook_cron_queue_info()</code>, it is possible to defined *Working queues*, that get automatically executed on cron.

<?php
function aggregator_cron_queue_info() {
  $queues['aggregator_feeds'] = array(
    'worker callback' => 'aggregator_refresh',
    'time' => 60,
  );
  return $queues;
}
?>

</div>

<div class="slide reachable" style="left: 1500px" id="queues-implementation" markdown="1">

# Implementations

* **SQL (polling):** functional (in core)
* **Beanstalkd:** functional (http://drupal.org/project/beanstalkd)
* **RabbitMQ:** not yet
* **Amazon SQS:** not yet

</div>

</div>
