<div class="container" style="-webkit-transform: translate(-100px, -150px) rotate(220deg);">

<div class="point reachable" style="-webkit-transform: translate(0, -300px); width: 1500px; height: 400px"><span>●</span> File streaming</div>

<div class="slide reachable" id="file-streaming" markdown="1">

# File streaming

* Drupal 7 implements the PHP *Stream wrapper* interface and rely heavily on it for serving file assets.
* Files can now be stored and queried remotely.
* The file storage capabilities of the hosting platform can be leveraged (Amazon S3, Rackspace CloudFiles, Azure Blob storage, ...).
* No need for any *shared filesystem* anymore.
</div>

<div class="slide reachable" id="file-streaming-interface" style="left: 500px" markdown="1">

# The file streaming interface

* Each file has an **URL** in the form <code>scheme://file</code> (ex: <code>s3://images/damien-bebe.jpg</code>)
* **create**, **read**, **update**, and **delete** of the files is transparent to the PHP code
* **chmod** is also abstract (a Drupal extension of the Stream wrapper interface)
* Each file also exposes an **External URL**, accessible to the client browser

</div>

<div class="slide reachable" id="file-streaming-example" style="left: 1000px" markdown="1">

# Existing implementations

* The **Hash wrapper** (http://drupal.org/project/hash_wrapper), which allows to more easily scale local filesystem storage.
* No other implementations that I know of yet  
(do you know any?)
* Other possible uses:
 * Storing files in a **MongoDB GridFS** (that can be streamed directly by Nginx).
 * **Fast private files** implementation based on tokens using NginxHttpSecureDownload (expiring URLs) or cookie-based authentication.

</div>

</div>
